#define ORG .org
#define EQU .equ
#define DB  .db
#define DW  .dw

ORG 0100H
;
MONIT  EQU 0F800H
TV     EQU 0F80FH
KBRD   EQU 0F803H
MSG    EQU 0F818H
HEX    EQU 0F815H
WCUR   EQU 0F83CH

;

START:
  LXI SP,0F3C0H  
  MVI A,01FH
  CALL TV
  LXI H,TEXT1
  CALL MSG    
  CALL TABL
  LXI H,TEXT2
  CALL MSG
KB:  
  CALL KBRD
  CPI 'M'
  JZ MODIFY
  CPI 'Q'
  JZ MONIT
  CPI 'C'
  JZ CLEAR
  JMP KB

CLEAR:
  LXI H,TEXT5
  CALL MSG
  CALL KBRD
  CPI 'Y'
  JNZ START
  CALL INIT
  CALL STRT
  MVI A,0D0H
  CALL SEND8
  MVI A,08H
  CALL SEND8
  MVI B,56
CYC3:
  PUSH B
  XRA A
  CALL SEND8
  POP B
  DCR B
  JNZ CYC3
  CALL STOP
  JMP START
  
MODIFY:
  LXI H,TEXT3
  CALL MSG
  CALL KBRD 
  CALL TV
  CPI 03AH
  JC MD0
  SBI 55
MD0:  
  RAL
  RAL
  RAL
  RAL
  ANI 0F0H
  MOV C,A ;  
  CALL 0F803H
  CALL 0F80FH
  CPI 03AH
  JC MD1
  SBI 55
MD1:  
  ANI 0FH
  ORA C 
  PUSH PSW
  CALL INIT
  CALL STRT
  MVI A,0D0H
  CALL SEND8
  POP PSW
  CALL SEND8   
  LXI H,TEXT4
  CALL MSG
  CALL KBRD 
  CALL TV
  CPI 03AH
  JC MD2
  SBI 55
MD2:  
  RAL
  RAL
  RAL
  RAL
  ANI 0F0H
  MOV C,A ;  
  CALL 0F803H
  CALL 0F80FH
  CPI 03AH
  JC MD3
  SBI 55
MD3:  
  ANI 0FH
  ORA C 

  CALL SEND8 
  CALL STOP
  JMP START
  
TABL:
  LXI H,0200H
  CALL WCUR
  LXI H,TEXT6
  CALL MSG
  CALL INIT
  CALL STRT
  MVI A,0D0H
  CALL SEND8
  XRA A
  CALL SEND8
  CALL STOP
  NOP
  CALL STRT
  MVI A,0D1H
  CALL SEND8
  MVI B,0
CYC2:
  PUSH B
  MOV A,B
  CALL HEX
  MVI A,' '
  CALL TV
  CALL TV
  MVI B,16
CYC1:
  PUSH B
  XRA A
  CALL READ8
  CALL HEX
  MVI A,' '
  CALL TV
  POP B
  DCR B
  JNZ CYC1
  MVI A,13
  CALL TV
  MVI A,10
  CALL TV
  POP B
  MVI A,16
  ADD B
  MOV B,A
  CPI 040H
  JNZ CYC2
  MVI A,1
  CALL READ8
  CALL STOP
  RET
  
TEXT1 DB "sodervimoe pamqti DS1307:",13,10,10,0  
TEXT2 DB 13,10,"izmenitx sodervimoe q~ejki - M",13,10,"wyhod w Monitor - Q",13,10,"o~istitx RAM (08H-3FH) - C",13,10,10,0 
TEXT3 DB "q~ejka nomer (HEX):",0
TEXT4 DB 13,10,"~islo (HEX): ",0
TEXT5 DB 13,10,"wy uwereny? (Y/N)",0
TEXT6 DB "    00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F",13,10,10,0

INIT: ; I2C procedures
  MVI A,1
  STA 0F765H
  STA 0F764H
  RET
STRT:
  XRA A
  STA 0F764H
  NOP
  STA 0F765H
  RET
STOP:
  XRA A
  STA 0F764H
  MVI A,1
  STA 0F765H
  NOP
  STA 0F764H
  RET
SEND8:
  MVI B,8
S80:
  RLC
  PUSH PSW
  JNC S81
  MVI A,1
  STA 0F764H
  JMP S82
S81:
  XRA A
  STA 0F764H
S82:
  MVI A,1
  STA 0F765H
  NOP
  XRA A
  STA 0F765H
  INR A
  STA 0F764H
  POP PSW
  DCR B
  JNZ S80
  MVI A,1
  STA 0F765H
  LDA 0F764H
  PUSH PSW
  XRA A
  STA 0F765H
  POP PSW
  RET
READ8:
  MVI B,8
  PUSH PSW
  XRA A
  MOV C,A
  INR A
  STA 0F764H
RD80:
  MOV A,C
  RAL
  MOV C,A
  MVI A,1
  STA 0F765H
  LDA 0F764H
  ANI 1
  ADD C
  MOV C,A
  XRA A
  STA 0F765H
  DCR B
  JNZ RD80
  POP PSW
  STA 0F764H
  MVI A,1
  STA 0F765H
  XRA A
  STA 0F765H
  MOV A,C
  RET

.END